<template>
    <div>
        <div class="alert alert-info text-center" role="alert">
            <p>Password reset token has been sent to your email. Please paste the token here.</p>
        </div>
        <form @submit.prevent="onSubmit">
            <div class="form-group">
                <label for="resetToken">Reset Token</label>
                <input type="text"
                       id="resetToken"
                       class="form-control"
                       v-model="resetToken"
                       :class="{'is-invalid': $v.resetToken.$error}"/>
                <span class="invalid-feedback">
                        <span v-if="!$v.resetToken.required">
                            Please enter the reset token.
                        </span>
                </span>
            </div>
            <div class="form-group">
                <label for="newPassword">New Password</label>
                <input type="password"
                       id="newPassword"
                       class="form-control"
                       v-model="newPassword"
                       :class="{'is-invalid': $v.newPassword.$error}"/>
                <span class="invalid-feedback">
                        <span v-if="!$v.newPassword.required">
                            Please enter the new password.
                        </span>
                </span>
            </div>
            <button class="btn btn-primary"
                    type="submit"
                    style="width:80px">
                Confirm
            </button>
        </form>
    </div>
</template>

<script>
    import {required} from 'vuelidate/lib/validators';
    import UserService from "../../services/user.service";
    export default {
        data() {
            return {
                resetToken: '',
                newPassword: ''
            }
        },
        validations: {
            resetToken: {
                required
            },
            newPassword: {
                required
            }
        },
        methods: {
            onSubmit() {
                this.$v.$touch();
                const formData = {
                    password: this.newPassword
                };
                UserService.resetPassword(formData, this.resetToken).subscribe(res => {
                    UserService.getCurrentUser(res.data.token).subscribe(response => {
                        this.$store.dispatch('login', {token: res.data.token, username: response.data.data.username});
                        this.$router.replace('/shop');
                    })
                })
            }
        }
    }
</script>
